#include "ventanai.h"
#include "configi.h"
#include "imagenes.h"
#include <qsettings.h>
#include <qmessagebox.h>
#include <qstring.h>
#include <qlineedit.h>
#include <qtextedit.h>
#include <qpushbutton.h>
#include <qlistview.h>
#include <qpixmap.h>
#include <qfile.h>
#include <qtextstream.h>
#include <qprogressdialog.h>
#include <qapplication.h>
#include <qregexp.h>
#include <stdlib.h>
#include <qlabel.h>
#include <qtimer.h>
#include <qcombobox.h>
#include <qdir.h>
#include <qsplitter.h>
#include <qaction.h>
#include <qstringlist.h>
#include <qstatusbar.h> 
#include <qheader.h>
#include <qfontdialog.h> 
#include <qcolordialog.h>
#include <qfiledialog.h> 

QString argumentosMame="";
QString fxmame;
QString mamehistoryF;
QString mameinfoF;
QString mameromdirF;
QString VER="2.0.6";
QString snapshots,cabinets,flyers,titles,marquees;
int filtrar;
int ejecutando;
int totalJuegos;
QListViewItem * itemG;
QProgressDialog * progressG;
int cantG;
int totalG;
QListViewItemIterator itVerifica;
QLabel * lab1;
QLabel * lab2;
QLabel * lab3;

ventanai::ventanai(QWidget *parent, const char *name ) : ventana(parent,name) {

//CONSTRUCCTOR
//--------------------

QSettings conf;

//crea directorios
QString home=QDir::homeDirPath();
QFile d1(home + "/.qtmame");
if (!d1.exists() ) {
    QDir d(home + "/.qtmame");
    if ( !d.exists() ) {
          d.mkdir(home + "/.qtmame");
     }
}
QFile d2(home + "/.qtmame/tmp");
if (!d2.exists() ) {
    QDir d(home + "/.qtmame/tmp");
    if ( !d2.exists() ) {
          d.mkdir(home + "/.qtmame/tmp");
     }
}


QString mameinfodir=conf.readEntry( "/qtmame/general/mameinfo", "~/.xmame/mameinfo.dat" );
QString mamehistorydir=conf.readEntry( "/qtmame/general/mamehistory", "~/.xmame/history.dat" );
mameromdirF=conf.readEntry( "/qtmame/general/mameromdir", "~/.xmame/roms" );
snapshots=conf.readEntry( "/qtmame/general/snapshots", "~/.xmame/snap" );
cabinets=conf.readEntry( "/qtmame/general/cabinets", "~/.xmame/cabinets" );
flyers=conf.readEntry( "/qtmame/general/flyers", "~/.xmame/flyers" );
titles=conf.readEntry( "/qtmame/general/titles", "~/.xmame/titles" );
marquees=conf.readEntry( "/qtmame/general/marquees", "~/.xmame/marquees" );
mameinfodir.replace(QRegExp("~"),home);
mamehistorydir.replace(QRegExp("~"),home);
mameromdirF.replace(QRegExp("~"),home);
snapshots.replace(QRegExp("~"),home);
cabinets.replace(QRegExp("~"),home);
flyers.replace(QRegExp("~"),home);
titles.replace(QRegExp("~"),home);
marquees.replace(QRegExp("~"),home);


// acomodo spliter
QValueList< int > sizes;
int spli1=conf.readNumEntry( "/qtmame/general/splitter1", 250 );
int spli2=conf.readNumEntry( "/qtmame/general/splitter2", 115 );
sizes << spli1 << spli2;
Splitter4->setSizes(sizes);

// maximizado
int max=conf.readNumEntry( "/qtmame/general/maximizado", 0 );
if (max) this->showMaximized();

//titulo
this->setCaption("Qtmame " + VER);

//status bar

//lab1 = new Q
lab1 = new QLabel(statusBar(),"slab1");
lab1->setText(" ");
lab2 = new QLabel(statusBar(),"slab2");
lab2->setText(" ");
lab2->setMinimumWidth ( 80 );
lab2->setAlignment ( AlignHCenter );
lab3 = new QLabel(statusBar(),"slab3");
lab3->setText(" ");
lab3->setMinimumWidth ( 110 );
lab3->setAlignment ( AlignHCenter );

statusBar()->addWidget(lab1,1,TRUE);
statusBar()->addWidget(lab2,0,TRUE);
statusBar()->addWidget(lab3,0,TRUE);

lab1->show();
lab2->show();
lab3->show();

//fuentes
QFont font;
QFont font1;
font.fromString( conf.readEntry( "/qtmame/general/fuenteListado", "" ) );
list1->setFont(font);
font1.fromString( conf.readEntry( "/qtmame/general/fuenteInfo", "" ) );
datos->setFont(font1);

//colores
QColor color1,co2;
color1.setNamedColor(conf.readEntry( "/qtmame/general/colorFuentes", "#000000" ));
list1->setPaletteForegroundColor(color1);
statusBar()->setPaletteForegroundColor(color1);
co2.setNamedColor(conf.readEntry( "/qtmame/general/colorFondo", "#FFFFFF" ));
this->setPaletteBackgroundColor(co2);
list1->setPaletteBackgroundColor(co2);
statusBar()->setPaletteBackgroundColor(co2);
QPalette pal;
pal=list1->palette();
datos->setPalette( pal );

//imagen fondo
QString iFondo;
iFondo=conf.readEntry( "/qtmame/general/imagenFondo", "/usr/local/share/qtmame/bkground.png" );
QFile fF(iFondo);
if (fF.exists()) {
       QPixmap img(iFondo);
       list1->setPaletteBackgroundPixmap(img);
       this->setPaletteBackgroundPixmap(img);
       QPalette pal;
       pal=list1->palette();
       datos->setPalette( pal );
       statusBar()->setPaletteBackgroundPixmap(img);
}

// total de juegos
totalJuegos=conf.readNumEntry( "/qtmame/general/totaljuegos", 3792 );
QString mostrar;
mostrar.setNum(totalJuegos);
lab3->setText("  " + mostrar + tr(" Juegos "));

//variables
filtrar=1;
ejecutando=0;
// cargo history
               QFile f(mamehistorydir);
               if (f.exists()) {
                    if ( f.open(IO_ReadOnly) ) {
                         QTextStream t2( &f );
                         mamehistoryF=t2.read();
                    }
               }
               else{
                    mamehistoryF="";
               }

//
// cargo mameinfo
               QFile f2(mameinfodir);
               if (f2.exists()) {
                    if ( f2.open(IO_ReadOnly) ) {
                         QTextStream t3( &f2 );       
                         mameinfoF=t3.read();
                    }
               }
               else {
                    mameinfoF="";
               }
//
//argumentos
fxmame=conf.readEntry( "/qtmame/general/fxmame", "X11" );
argumentosMame=conf.readEntry( "/qtmame/general/argumentosmame", "" );
fxmame.replace(QRegExp("~"),home);
argumentosMame.replace(QRegExp("~"),home);
     
ajustarcolumnas();

statusBar()->hide();
previa->hide();
vista->hide();
datos->hide();
list1->hide();
info->hide();

lcargando = new QLabel( this, "lcargando" );
lcargando->setText( tr( "<b>Cargando Listado ... Espere." ) );
lcargando->setGeometry( QRect( 15, 70, 500, 19 ) );
lcargando->show();
QTimer::singleShot( 1000, this, SLOT(recargalista()) );

}

ventanai::~ventanai(){
guardarAnchoColumnas();

QSettings conf;    //guarda la conf antes de salir

//splitter
QValueList<int> listt = Splitter4->sizes();
QValueList<int>::Iterator itt = listt.begin();
conf.writeEntry( "/qtmame/general/splitter1", *itt );
++itt;
conf.writeEntry( "/qtmame/general/splitter2", *itt );        


//fuentes
conf.writeEntry( "/qtmame/general/fuenteListado",  list1->font().toString());
conf.writeEntry( "/qtmame/general/fuenteInfo",  datos->font().toString());

//colorres
conf.writeEntry( "/qtmame/general/colorFuentes",  list1->foregroundColor().name());

conf.writeEntry( "/qtmame/general/vista", vista->currentItem() );

if(info->isOn()) conf.writeEntry( "/qtmame/general/info", "true" );
else conf.writeEntry( "/qtmame/general/info", "false" );

int max=this->isMaximized();
if(max) conf.writeEntry( "/qtmame/general/maximizado", 1 );
else conf.writeEntry( "/qtmame/general/maximizado", 0 );

int ftodos=todos->isOn();
int fdisponibles=disponibles->isOn();
int fnodisponibles=nodisponibles->isOn();
int fneogeo=neogeo->isOn();

if (ftodos) conf.writeEntry( "/qtmame/general/filtro", "todos" );
else if (fdisponibles) conf.writeEntry( "/qtmame/general/filtro", "disponibles" );
else if (fnodisponibles) conf.writeEntry( "/qtmame/general/filtro", "nodisponibles" );
else if (fneogeo) conf.writeEntry( "/qtmame/general/filtro", "neogeo" );


QListViewItem * item;
QString lr="";
QString lr2="";
item=list1->selectedItem();

if (item!=0) {
     lr=item->text(4);
     conf.writeEntry( "/qtmame/general/ultimojuego", lr );
}

//guardar el listado
list1->setSorting(0,TRUE);
     lr="";
    QListViewItemIterator it( list1 );
    while ( it.current() != 0 ) {
          item=it.current();
          lr.append(item->text(0));
          lr.append("\t");
          lr.append(item->text(1));
          lr.append("\t");
          lr.append(item->text(2));
          lr.append("\t");
          lr.append(item->text(3));
          lr.append("\t");
          lr.append(item->text(4));
          lr.append("\t");
          lr.append(item->text(5));
          lr.append("\t");
          lr.append(item->text(6));
          lr.append("\t");
          lr.append(item->text(7));
          lr.append("\t");
          lr.append(item->text(8));
          lr.append("\t");
          lr.append(item->text(9));
          lr.append("\t");
          lr.append(item->text(10));
          lr.append("\n");
//          	QMessageBox:: warning( this, tr("Error"), tr("No gos:" + lr));
         ++it;
    }
QString home=QDir::homeDirPath();
QFile f(home + "/.qtmame/listado078");
if ( !f.open( IO_WriteOnly ) ) {
	QMessageBox:: warning( this, tr("Error"), tr("No se pudo guardar el listado de juegos"));
	return;
    }
QTextStream t( &f );
t << lr;
f.close();



}

void ventanai::ejecutar(){
     if (ejecutando) return;
//
QSettings conf;
QStringList argumentos;
QStringList temp;

argumentos << fxmame;

//me muestra los argumentos usados
//QMessageBox:: warning( this, tr("Error"), );

   qDebug( argumentosMame );
   
//paso los datos en forma de string list
temp= QStringList::split( " ", argumentosMame );
for ( QStringList::Iterator it = temp.begin(); it != temp.end(); ++it ) {
    argumentos << *it;
}


QListViewItem * item;
QString lr="";
item=list1->selectedItem();
if (item!=0) {
     lr=item->text(4);
        proc = new QProcess( this );
        proc->setName(lr);
        proc->setArguments( argumentos );
        proc->addArgument( lr );

        connect( proc, SIGNAL(processExited()),
                this, SLOT(leerexit()) );
// limpio salida
        if ( !proc->start() ) {
            QMessageBox:: warning( this, tr("Error"), tr("No se pudo ejecutar"));
        }
        else {
             ejecutando=1;
             this->setCaption("Qtmame " + VER + tr(" Ejecutando: ") + item->text(0));
        }
}
}

void ventanai::leerexit(){
            ejecutando=0;
             this->setCaption("Qtmame " + VER);
            QString salida="";
            salida.append(proc->readStdout());
            if (salida.find( QRegExp("\nERROR: "), 0 )!=-1) {
    	     QMessageBox:: warning( this, tr("Error al cargar"), salida);

               QListViewItem * item;
               QString lr=proc->name();
               item=list1->findItem(lr,4);
               if (item!=0) {
                    lr=item->text(5);
                    if(lr.compare(tr("Si"))==0){
                         item->setText(5, tr("Mal"));
                         QPixmap badrom( ( const char** ) badrom_data );
                         item->setPixmap( 0, badrom );
                    }
               }
            }
            else{
               QListViewItem * item;
               QString lr=proc->name();
               item=list1->findItem(lr,4);
               if (item!=0) {
                    lr=item->text(5);
                    bool ok;
                    QString Jug;
                    Jug.setNum((item->text(8).toInt(&ok,10)+1));
                    item->setText(8,Jug);
                    
                    if(lr.compare(tr("No"))==0){
                         item->setText(5, tr("Si"));
                         QPixmap imagen3( ( const char** ) image3_data );
                         item->setPixmap( 0, imagen3 );
                    }
                    else if(lr.compare(tr("Mal"))==0){
                         item->setText(5, tr("Si"));
                         QPixmap imagen3( ( const char** ) image3_data );
                         item->setPixmap( 0, imagen3 );
                    }
               }
            }
}


void ventanai::cambiaseleccion(){
QSettings conf;
QString directorio;


if (vista->currentText().compare("Snapshots")==0){
     directorio=snapshots;
     }
else if (vista->currentText().compare("Cabinets")==0){
     directorio=cabinets;
     }
else if (vista->currentText().compare("Titles")==0){
     directorio=titles;
     }
else if (vista->currentText().compare("Flyers")==0){
     directorio=flyers;
     }
else if (vista->currentText().compare("Marquees")==0){
     directorio=marquees;
     }
QString home=QDir::homeDirPath();
directorio.replace(QRegExp("~"),home);



     QString lr="";
     QListViewItem * item;
     item=list1->selectedItem();
     if (item!=0) {
          lab1->setText(" " + item->text(0));
          lab2->setText(tr(" Rom: ") + item->text(5) +" ");

          lr=item->text(4);
          QFile f(directorio + "/" +lr+".png");

          if (f.exists()) {
                    QPixmap img(directorio + "/" +lr+".png");
                    previa->setPixmap(img);
          }                   
         else{
                    lr=item->text(3);
                   QFile f2(directorio + "/" +lr+".png");
                    if (f2.exists()) {
                              QPixmap img(directorio + "/" +lr+".png");
                              previa->setPixmap(img);
                    }
                    else{
                         lr=item->text(4);
                         QFile f(directorio + "/" +lr+".jpg");

                         if (f.exists()) {
                              QPixmap img(directorio + "/" +lr+".jpg");
                              previa->setPixmap(img);
                         }
                        else{
                              lr=item->text(3);
                             QFile f2(directorio + "/" +lr+".jpg");
                              if (f2.exists()) {
                                   QPixmap img(directorio + "/" +lr+".jpg");
                                   previa->setPixmap(img);
                              }
                              else{
                                   QPixmap img("/usr/local/share/qtmame/qtmame3.png");
                                   previa->setPixmap(img);

                              }
                       }                                                                                                                       
                    } // del else que prueba con jpg
                    
         }// del else si archivo no existe
         //info
         if(info->isOn()){
               datos->show();
               //history
               int inicio=mamehistoryF.find(item->text(4) + ",",0);
                    if (inicio!=-1) {
                         int fin=mamehistoryF.find("$end",inicio);
                         QString mostrar=mamehistoryF.mid(inicio,fin-inicio);
                         int bio=mostrar.find("$bio",0);
                         if (bio!=-1) {
                               mostrar.remove(0,bio+6);
                         }
                          datos->setText(mostrar);
                    }
                    else{
                         datos->setText("");
                    }

               //history
               int inicio2=mameinfoF.find("$info=" + item->text(4)+"\n" ,0);
                    if (inicio2!=-1) {
                         int fin2=mameinfoF.find("$end",inicio2);
                               if (fin2!=-1) {
                                        QString mostrar2=mameinfoF.mid(inicio2,fin2-inicio2);
                                        int mame=mostrar2.find("$mame",0);
                                        if (mame!=-1) {
                                                   mostrar2.remove(0,mame+6);
                                        }
                                        datos->append(mostrar2);
                               }

                    }
                    else{
                         int inicio3=mameinfoF.find("$info=" + item->text(3)+"\n" ,0);
                         if (inicio3!=-1) {
                              int fin3=mameinfoF.find("$end",inicio3);
                                    if (fin3!=-1) {
                                             QString mostrar3=mameinfoF.mid(inicio3,fin3-inicio3);
                                             int mame3=mostrar3.find("$mame",0);
                                             if (mame3!=-1) {
                                                        mostrar3.remove(0,mame3+6);
                                             }
                                             datos->append(mostrar3);
                                    }

                         }
                    }    //del else

         datos->setCursorPosition(0,0);
         } //termina si info
         else {
               datos->setText("");
               datos->hide();
         }

     } //termina si hay algo seleccionado
}

void ventanai::recargalista(){
QPixmap imagen3( ( const char** ) image3_data );
QPixmap imagen5( ( const char** ) image5_data );
QPixmap badrom( ( const char** ) badrom_data );

QListViewItem * item;
QListViewItem * itemPadre;
QSettings conf;

list1->hide();

QString home=QDir::homeDirPath();
QFile f(home + "/.qtmame/listado078");
if (!f.exists() ){
//ATENCION CAMBIAR ACA SI CAMBIA LA VERSION
     f.setName("/usr/local/share/qtmame/listado078");
}

if (f.exists()) {
     if ( f.open(IO_ReadOnly) ) {
  //       int cant=0;
          QTextStream t2( &f );
          QString s2="",s="",s3="",lugar="";
          s2=t2.read();
          QTextStream t( &s2,IO_ReadOnly);
          while ( !t.eof() ) {        // until end of file...
             s=t.readLine();
             s3=s;
             //veo  clon
             int i = s3.find( QRegExp("\t"), 0 );
             s3.remove( 0, i+1 );
             i = s3.find( QRegExp("\t"), 0 );
             s3.remove( 0, i+1 );
             i = s3.find( QRegExp("\t"), 0 );
             s3.remove( 0, i+1 );
             i = s3.find( QRegExp("\t"), 0 );
//             item->setText( 3, s3.left(i) );  /// s3.left(i) contiene el nombre del clon
             if (s3.left(i).length()==0){
                  item = new QListViewItem(list1);
                  itemPadre = item;
             }
             else {
                  item = new QListViewItem(itemPadre);
             }                    
                            
             //FIM veo CLON
             i = s.find( QRegExp("\t"), 0 );
             item->setText( 0, s.left(i) );
             s.remove( 0, i+1 );
             i = s.find( QRegExp("\t"), 0 );
             item->setText( 1, s.left(i) );
             s.remove( 0, i+1 );
             i = s.find( QRegExp("\t"), 0 );
             item->setText( 2, s.left(i) );
             s.remove( 0, i+1 );
             i = s.find( QRegExp("\t"), 0 );
             item->setText( 3, s.left(i) );
             s.remove( 0, i+1 );
             i = s.find( QRegExp("\t"), 0 );
             item->setText( 4, s.left(i) );
             s.remove( 0, i+1 );
             i = s.find( QRegExp("\t"), 0 );
             item->setText( 5, s.left(i) );
             s.remove( 0, i+1 );
             i = s.find( QRegExp("\t"), 0 );
             item->setText( 6, s.left(i) );
             s.remove( 0, i+1 );
             i = s.find( QRegExp("\t"), 0 );
             item->setText( 7, s.left(i) );
             s.remove( 0, i+1 );
             i = s.find( QRegExp("\t"), 0 );
             item->setText( 8, s.left(i) );
             s.remove( 0, i+1 );
             i = s.find( QRegExp("\t"), 0 );
             item->setText( 9, s.left(i) );
             s.remove( 0, i+1 );
             i = s.find( QRegExp("\t"), 0 );
             item->setText( 10, s.left(i) );
             s.remove( 0, i+1 );
             item->setText( 11, s );

             if (item->text(5).compare(tr("Si"))==0) {
                    item->setPixmap( 0, imagen3 );
              }
             else if (item->text(5).compare(tr("No"))==0) {
                         item->setPixmap( 0, imagen5 );
             }
             else if (item->text(5).compare(tr("Mal"))==0) {
                         item->setPixmap( 0, badrom );
             }

          }
     }
f.close();
}
lcargando->hide();

previa->show();
vista->show();
datos->show();
info->show();
list1->show();
statusBar()->show();

vista->setCurrentItem(conf.readNumEntry( "/qtmame/general/vista", 0 ));
QString infoestado=conf.readEntry( "/qtmame/general/info", "true" );
if (infoestado.compare("true")==0) info->setOn(true);
else info->setOn(false);


QString filtro=conf.readEntry( "/qtmame/general/filtro", "todos" );
if (filtro.compare("todos")==0) todos->setOn(1);
else if (filtro.compare("disponibles")==0) disponibles->setOn(1);
else if (filtro.compare("nodisponibles")==0) nodisponibles->setOn(1);
else if (filtro.compare("neogeo")==0) neogeo->setOn(1);

list1->setFocus();
//  carga configuracion
int col0=conf.readNumEntry( "/qtmame/general/col0", 300 );
list1->setColumnWidth(0, col0);
int col1=conf.readNumEntry( "/qtmame/general/col1", 100 );
list1->setColumnWidth(1, col1);
int col2=conf.readNumEntry( "/qtmame/general/col2", 100 );
list1->setColumnWidth(2, col2);
int col3=conf.readNumEntry( "/qtmame/general/col3", 100 );
list1->setColumnWidth(3, col3);
int col4=conf.readNumEntry( "/qtmame/general/col4", 100 );
list1->setColumnWidth(4, col4);
int col5=conf.readNumEntry( "/qtmame/general/col5", 100 );
list1->setColumnWidth(5, col5);
QString lr=conf.readEntry( "/qtmame/general/ultimojuego", "005" );
               item=list1->findItem(lr,4);
               if (item!=0) {
                          list1->setSelected(item,1);
                          list1->ensureItemVisible(item);
               }
//aca termina de recargar la lista
               
}
void ventanai::confxmame(){
	(new configi())->show();
}

void ventanai::cbuscarroms(){
guardarAnchoColumnas();
QPixmap imagen3( ( const char** ) image3_data );
QPixmap imagen5( ( const char** ) image5_data );
previa->hide();
vista->hide();
datos->hide();
list1->hide();
info->hide();

QListViewItem * item;

int total=totalJuegos;

QProgressDialog progress( tr("Buscando roms de Juegos..."), tr("Cancelar"), total ,this, "progress", TRUE );
int cant=0;
//QMessageBox:: warning( this, "Error", item->text(4));
QListViewItemIterator it( list1 );
    while ( it.current() != 0 ) {
           item=it.current();
                    cant++;
                    progress.setProgress( cant );
                    if ( progress.wasCancelled() )break;

             QFile farch(mameromdirF+"/" + item->text(4) + ".zip");
             QFile fdir(mameromdirF+"/" + item->text(4));
             if (farch.exists()) {
                    item->setPixmap( 0, imagen3 );
                    item->setText( 5, tr("Si") );
              }
             else {
                  if (fdir.exists()) {
                         item->setPixmap( 0, imagen3 );
                         item->setText( 5, tr("Si") );
                  }
                  else {
                         item->setPixmap( 0, imagen5 );
                         item->setText( 5, tr("No") );
                  }
              }
        ++it;

    }
progress.setProgress( total );
previa->show();
vista->show();
datos->show();
info->show();
list1->show();
//  carga configuracion
QTimer::singleShot( 1000, this, SLOT(ajustarcolumnas()) );
}

void ventanai::cgenerarlistado(){
QMessageBox:: information( this, tr("Catver..."), tr("El archivo catver.ini debe estar en: /usr/local/share/qtmame/catver.ini"));

//oculta
previa->hide();
vista->hide();
datos->hide();
list1->hide();
info->hide();

progressG= new QProgressDialog( tr("Generando listado de roms... "), tr("Cancelar"), 8 ,this, "vprogressgl", TRUE );
progressG->show();

QString home=QDir::homeDirPath();
QFile f(home + "/.qtmame/tmp/lf");
f.remove();
QFile f2(home + "/.qtmame/tmp/lg");
f2.remove();
QFile f3(home + "/.qtmame/tmp/lcl");
f3.remove();
QFile f4(home + "/.qtmame/tmp/lsf");
f4.remove();
QFile f5(home + "/.qtmame/tmp/lrs");
f5.remove();
//
        proc = new QProcess( this );
        proc->setName("lf");
        proc->addArgument( fxmame );
        proc->addArgument( "-lf" );
        proc->addArgument( "-out" );
        proc->addArgument( home + "/.qtmame/tmp/lf" );

        connect( proc, SIGNAL(processExited()),
                this, SLOT(exitlf()) );
// arranca?
        if ( !proc->start() ) {
            QMessageBox:: warning( this, tr("Error"), tr("No puedo ejecutar: xmame -lf "));
        }

}
void ventanai::generarlistado(){
guardarAnchoColumnas();

          if ( progressG->wasCancelled() ){
               previa->show();
               vista->show();
               datos->show();
               info->show();
               list1->show();
               return;
          }
list1->clear();
//
bool ok;
QListViewItem * item;
QListViewItem * itemClon;
QString home=QDir::homeDirPath();
QFile f(home + "/.qtmame/tmp/lf");
QFile f2(home + "/.qtmame/tmp/lg");
QFile f3(home + "/.qtmame/tmp/lcl");
QFile f4(home + "/.qtmame/tmp/lsf");
QFile f5(home + "/.qtmame/tmp/lrs");
QFile fcatver("/usr/local/share/qtmame/catver.ini");

QString sCatVer="";
QString catver="";
int ecat,ever;

if (fcatver.exists()) {
   if ( fcatver.open(IO_ReadOnly) ) {
       QTextStream tlcatver( &fcatver );
       sCatVer=tlcatver.read();
       ecat=sCatVer.find( "[Category]", 0 );
       ever=sCatVer.find( "[VerAdded]", 0 );      
   }
}

int i,j;
int cant=0;

if (f.exists()) {
 if (f2.exists()) {
  if (f3.exists()) {
   if (f4.exists()) {
    if (f5.exists()) {
     if ( f.open(IO_ReadOnly) ) {
      if ( f2.open(IO_ReadOnly) ) {
       if ( f3.open(IO_ReadOnly) ) {
        if ( f4.open(IO_ReadOnly) ) {
         if ( f5.open(IO_ReadOnly) ) {
          QTextStream tlnombre( &f );
          QTextStream tldatos( &f2 );
          QTextStream tlclones( &f3 );
          QTextStream tlfuentes( &f4 );
          QTextStream tltamanio( &f5 );
          QString s1="",s2="",s3="",s4="",s5="";

//saca cabezeras
          s1=tlnombre.readLine();
          s1=tlnombre.readLine();
          s2=tldatos.readLine();
          s2=tldatos.readLine();
          s3=tlclones.readLine();
          s3=tlclones.readLine();
          s4=tlfuentes.readLine();
          s4=tlfuentes.readLine();
          s5=tltamanio.readLine();
          s5=tltamanio.readLine();
          progressG->setProgress( 6 );          
          while ( !tlnombre.eof() ) {        // until end of file...
                    s1=tlnombre.readLine();
                    s2=tldatos.readLine();
                    s4=tlfuentes.readLine();
                    s5=tltamanio.readLine();

                    if (s1.compare("")==0){
                         break;
                         }
                    item = new QListViewItem(list1);
                    cant++;
//                    if (cant==000) break;
                    //rom
                    QString rom=s1;
                    rom.remove( 10, rom.length()-10 );
                    rom=rom.stripWhiteSpace();

                    //clones
                    QString clon=s3.left(9);
                    clon=clon.stripWhiteSpace();
                    if(clon.compare(rom)==0){
                               QString okclon=s3.right(9);
                               okclon=okclon.stripWhiteSpace();
                               item->setText( 3, okclon );
                               s3=tlclones.readLine();
                    }


                    //rom 2
                    item->setText( 4, rom );
                    //nombre
                    QString nombre=s1;
                    nombre=nombre.remove( 0, 11 );
                    nombre.remove(nombre.length()-1,1);
                    item->setText( 0, nombre );

                    //remover la descripcion                  
                    QString datos=s2;
                    i = datos.find( nombre, 0 );
                    if (i==-1) {
                           QMessageBox:: warning( this, tr("Error"), tr("No se encontraron las descripciones de una rom: ") + nombre);
                    }
                    datos.remove(i,datos.length()-i);
                    //anio
                    QString anio=datos;
                    anio.remove( 4, anio.length()-4 );
                    item->setText( 2, anio );
                    //creador
                    QString creador=datos;
                    creador=creador.remove( 0, 5 );
                    creador=creador.stripWhiteSpace();
                    item->setText( 1, creador );
                    //driver
                    QString drv=s4;
                    drv=drv.remove( 0, 21 );
                    drv.remove(drv.length()-2,2);
                    drv=drv.stripWhiteSpace();
                    item->setText( 7, drv );
                    //tamanio
                    QString tam=s5,vacioTam;
                    int cantTam;
                    tam=tam.remove( 0, 15 );
                    tam=tam.stripWhiteSpace();
                    cantTam=tam.toInt( &ok, 10 );
                    cantTam=cantTam/1024;
                    tam.setNum(cantTam);
                    vacioTam.fill( '0', (6-tam.length()) );
                    tam.insert( 0, vacioTam );
                    item->setText( 6, tam );
                    //jugado
                    item->setText( 8, "0" );
                    //catver
                    //cat -----------------------------------------
                    i = sCatVer.find( "\n" + rom + "=", ecat );
                    if (i==-1) {
                    }
                    else {
                         j=sCatVer.find( "\n", i+1 );
                         catver=sCatVer.mid( i+1, j-(i+1) );
                         catver.remove(0,(catver.find( "=", 0 )+1));
                         catver.remove("\r");                         
                         item->setText( 9, catver );
                    }
                    //version ----------------------------------------
                    i = sCatVer.find( "\n" + rom + "=", ever );
                    if (i==-1) {
                    }
                    else {
                         j=sCatVer.find( "\n", i+1 );
                         catver=sCatVer.mid( i+1, j-(i+1) );
                         catver.remove(0,(catver.find( "=", 0 )+1));
                         catver.remove("\r");                        
                         item->setText( 10, catver );
                    }
          
          }   // del while
         
         }
       }
     }
    }
   }
   
    }
   } 
  }
 }
}
QSettings conf;
totalJuegos=cant;
conf.writeEntry( "/qtmame/general/totaljuegos", cant );
progressG->setProgress( 7 );

QListViewItem * item2;
QListViewItemIterator it( list1 );
while ( it.current() != 0 ) {
         item=it.current();
         if (item->text(3).isEmpty()){
              ++it;
         }
         else{
              itemClon=list1->findItem ( item->text(3), 4, ExactMatch );
              item2 = new QListViewItem(itemClon);
              item2->setText(0,item->text(0));
              item2->setText(1,item->text(1));
              item2->setText(2,item->text(2));
              item2->setText(3,item->text(3));
              item2->setText(4,item->text(4));
              item2->setText(5,item->text(5));
              item2->setText(6,item->text(6));
              item2->setText(7,item->text(7));
              item2->setText(8,item->text(8));
              item2->setText(9,item->text(9));
              item2->setText(10,item->text(10));
              ++it;
              delete item;
         }
}
progressG->setProgress( 8 );


//muestra
previa->show();
vista->show();
datos->show();
info->show();
list1->show();


f.close();
f2.close();
f3.close();
f4.close();
QTimer::singleShot( 1000, this, SLOT(ajustarcolumnas()) );
          if ( progressG->wasCancelled() ){
               previa->show();
               vista->show();
               datos->show();
               info->show();
               list1->show();
               return;
          }

}

void ventanai::guardarAnchoColumnas(){
QSettings conf;    //guarda la conf antes de salir
int col0=list1->columnWidth(0);
if (col0!=0) conf.writeEntry( "/qtmame/general/col0", col0 );
int col1=list1->columnWidth(1);
if (col1!=0) conf.writeEntry( "/qtmame/general/col1", col1 );
int col2=list1->columnWidth(2);
if (col2!=0) conf.writeEntry( "/qtmame/general/col2", col2 );
int col3=list1->columnWidth(3);
if (col3!=0) conf.writeEntry( "/qtmame/general/col3", col3 );
int col4=list1->columnWidth(4);
if (col4!=0) conf.writeEntry( "/qtmame/general/col4", col4 );
int col5=list1->columnWidth(5);
if (col5!=0) conf.writeEntry( "/qtmame/general/col5", col5 );
int col6=list1->columnWidth(6);
if (col6!=0) conf.writeEntry( "/qtmame/general/col6", col6 );
int col7=list1->columnWidth(7);
if (col7!=0) conf.writeEntry( "/qtmame/general/col7", col7 );
int col8=list1->columnWidth(8);
if (col8!=0) conf.writeEntry( "/qtmame/general/col8", col8 );
int col9=list1->columnWidth(9);
if (col9!=0) conf.writeEntry( "/qtmame/general/col9", col9 );
int col10=list1->columnWidth(10);
if (col10!=0) conf.writeEntry( "/qtmame/general/col10", col10 );

int colD0=list1->header()->mapToIndex(0);
conf.writeEntry( "/qtmame/general/colD0", colD0 );

int colD1=list1->header()->mapToIndex(1);
conf.writeEntry( "/qtmame/general/colD1", colD1 );

int colD2=list1->header()->mapToIndex(2);
conf.writeEntry( "/qtmame/general/colD2", colD2 );

int colD3=list1->header()->mapToIndex(3);
conf.writeEntry( "/qtmame/general/colD3", colD3 );

int colD4=list1->header()->mapToIndex(4);
conf.writeEntry( "/qtmame/general/colD4", colD4 );

int colD5=list1->header()->mapToIndex(5);
conf.writeEntry( "/qtmame/general/colD5", colD5 );

int colD6=list1->header()->mapToIndex(6);
conf.writeEntry( "/qtmame/general/colD6", colD6 );

int colD7=list1->header()->mapToIndex(7);
conf.writeEntry( "/qtmame/general/colD7", colD7 );

int colD8=list1->header()->mapToIndex(8);
conf.writeEntry( "/qtmame/general/colD8", colD8 );

int colD9=list1->header()->mapToIndex(9);
conf.writeEntry( "/qtmame/general/colD9", colD9 );

int colD10=list1->header()->mapToIndex(10);
conf.writeEntry( "/qtmame/general/colD10", colD10 );


//
}

void ventanai::ajustarcolumnas(){
QSettings conf;
// acomodo List1
list1->setColumnWidthMode(0,QListView::Manual);
list1->setColumnWidthMode(1,QListView::Manual);
list1->setColumnWidthMode(2,QListView::Manual);
list1->setColumnWidthMode(3,QListView::Manual);
list1->setColumnWidthMode(4,QListView::Manual);
list1->setColumnWidthMode(5,QListView::Manual);
list1->setColumnWidthMode(6,QListView::Manual);
list1->setColumnWidthMode(7,QListView::Manual);
list1->setColumnWidthMode(8,QListView::Manual);
list1->setColumnWidthMode(9,QListView::Manual);
list1->setColumnWidthMode(10,QListView::Manual);

int col0=conf.readNumEntry( "/qtmame/general/col0", 300 );
list1->setColumnWidth(0, col0);
int col1=conf.readNumEntry( "/qtmame/general/col1", 100 );
list1->setColumnWidth(1, col1);
int col2=conf.readNumEntry( "/qtmame/general/col2", 100 );
list1->setColumnWidth(2, col2);
int col3=conf.readNumEntry( "/qtmame/general/col3", 100 );
list1->setColumnWidth(3, col3);
int col4=conf.readNumEntry( "/qtmame/general/col4", 100 );
list1->setColumnWidth(4, col4);
int col5=conf.readNumEntry( "/qtmame/general/col5", 100 );
list1->setColumnWidth(5, col5);
int col6=conf.readNumEntry( "/qtmame/general/col6", 100 );
list1->setColumnWidth(6, col6);
int col7=conf.readNumEntry( "/qtmame/general/col7", 100 );
list1->setColumnWidth(7, col7);
int col8=conf.readNumEntry( "/qtmame/general/col8", 100 );
list1->setColumnWidth(8, col8);
int col9=conf.readNumEntry( "/qtmame/general/col9", 100 );
list1->setColumnWidth(9, col9);
int col10=conf.readNumEntry( "/qtmame/general/col10", 100 );
list1->setColumnWidth(10, col10);

int colD0=conf.readNumEntry( "/qtmame/general/colD0", 0 );
list1->header()->moveSection(0,colD0);

int colD1=conf.readNumEntry( "/qtmame/general/colD1", 1 );
list1->header()->moveSection(1,colD1);

int colD2=conf.readNumEntry( "/qtmame/general/colD2", 2 );
list1->header()->moveSection(2,colD2);

int colD3=conf.readNumEntry( "/qtmame/general/colD3", 3 );
list1->header()->moveSection(3,colD3);

int colD4=conf.readNumEntry( "/qtmame/general/colD4", 4 );
list1->header()->moveSection(4,colD4);

int colD5=conf.readNumEntry( "/qtmame/general/colD5", 5 );
list1->header()->moveSection(5,colD5);

int colD6=conf.readNumEntry( "/qtmame/general/colD6", 6 );
list1->header()->moveSection(6,colD6);

int colD7=conf.readNumEntry( "/qtmame/general/colD7", 7 );
list1->header()->moveSection(7,colD7);

int colD8=conf.readNumEntry( "/qtmame/general/colD8", 8 );
list1->header()->moveSection(8,colD8);

int colD9=conf.readNumEntry( "/qtmame/general/colD9", 9 );
list1->header()->moveSection(9,colD9);

int colD10=conf.readNumEntry( "/qtmame/general/colD10", 10 );
list1->header()->moveSection(10,colD10);


}

void ventanai::exitlf(){
          progressG->setProgress( 1 );
          if ( progressG->wasCancelled() ){
               previa->show();
               vista->show();
               datos->show();
               info->show();
               list1->show();
               return;
          }
QString home=QDir::homeDirPath();
        proc = new QProcess( this );
        proc->setName("lg");
        proc->addArgument( fxmame );
        proc->addArgument( "-lg" );
        proc->addArgument( "-out" );
        proc->addArgument( home + "/.qtmame/tmp/lg" );

        connect( proc, SIGNAL(processExited()),
                this, SLOT(exitlg()) );
// arranca?
        if ( !proc->start() ) {
            QMessageBox:: warning( this, tr("Error"), tr("No puedo ejecutar: xmame -lg "));
        }

}
void ventanai::exitlg(){
          progressG->setProgress( 2 );
          if ( progressG->wasCancelled() )return;
QString home=QDir::homeDirPath();
        proc = new QProcess( this );
        proc->setName("lsf");
        proc->addArgument( fxmame );
        proc->addArgument( "-lsf" );
        proc->addArgument( "-out" );
        proc->addArgument( home + "/.qtmame/tmp/lsf" );

        connect( proc, SIGNAL(processExited()),
                this, SLOT(exitlsf()) );
// arranca?
        if ( !proc->start() ) {
            QMessageBox:: warning( this, tr("Error"), tr("No puedo ejecutar: xmame -lsf "));
        }
}
void ventanai::exitlsf(){
          progressG->setProgress( 3 );
          if ( progressG->wasCancelled() )return;
QString home=QDir::homeDirPath();
        proc = new QProcess( this );
        proc->setName("lrs");
        proc->addArgument( fxmame );
        proc->addArgument( "-lrs" );

        connect( proc, SIGNAL(processExited()),
                this, SLOT(exitlrs()) );
// arranca?
        if ( !proc->start() ) {
            QMessageBox:: warning( this, tr("Error"), tr("No puedo ejecutar: xmame -lrs "));
        }
}
void ventanai::exitlrs(){
QString lr="";
///
//guardar el listado
lr.append(proc->readStdout());

QString home=QDir::homeDirPath();
QFile f(home + "/.qtmame/tmp/lrs");
if ( !f.open( IO_WriteOnly ) ) {
	QMessageBox:: warning( this, tr("Error"), tr("No se pudo guardar el listado de juegos"));
	return;
    }
QTextStream t( &f );
t << lr;
f.close();


///

          progressG->setProgress( 4 );
          if ( progressG->wasCancelled() )return;
//QString home=QDir::homeDirPath();
        proc = new QProcess( this );
        proc->setName("lcl");
        proc->addArgument( fxmame );
        proc->addArgument( "-lcl" );
        proc->addArgument( "-out" );
        proc->addArgument( home + "/.qtmame/tmp/lcl" );

        connect( proc, SIGNAL(processExited()),
                this, SLOT(exitlcl()) );
// arranca?
        if ( !proc->start() ) {
            QMessageBox:: warning( this, tr("Error"), tr("No puedo ejecutar: xmame -lcl "));
        }
}

void ventanai::exitlcl(){
          progressG->setProgress( 5 );
          if ( progressG->wasCancelled() ){
               previa->show();
               vista->show();
               datos->show();
               info->show();
               list1->show();
               return;
          }
generarlistado();
}


void ventanai::vista_activated( const QString &nuevo ){
cambiaseleccion();
list1->setFocus();
}

void ventanai::info_toggled( bool ){
cambiaseleccion();
list1->setFocus();
}
void ventanai::acercade(){
statusBar()->message("Loading...");
QString mensaje="QtMame by iNGENI{}\n"
"Version "+VER+"\n\n"
"WEB: http://move.to/ingenio\n"
"E-Mail: ingenio@uol.com.ar\n\n"

+ tr("Colaboradores:\n\n") +
"   IngeniA \n"
"   Lecha\n"
"   Shake\n"
"   Override\n"
"   David\n"
"   Qtman";
		QMessageBox:: information( this, tr("Acerca de..."), mensaje);

}
//filtros
void ventanai::ftodos(bool onoff){
guardarAnchoColumnas();
int totalVisibles=0;

if (onoff){
  if (filtrar){
     QString lr="";
     QListViewItem * item;
     

    QListViewItemIterator it( list1 );
    while ( it.current() != 0 ) {
           item=it.current();
           item->setVisible(1);
           totalVisibles++;
        ++it;
    }
    //apago los otros
    filtrar=0;
    neogeo->setOn(0);
    romsmal->setOn(0);
    nodisponibles->setOn(0);
    disponibles->setOn(0);
    Cps1->setOn(0);
    Cps2->setOn(0);
    Jugados->setOn(0);
    filtrar=1;

  }   //termina filtrar
}
else {
  if (filtrar) todos->setOn(1);
}
QTimer::singleShot( 100, this, SLOT(ajustarcolumnas()) );
QString mostrar;mostrar.setNum(totalVisibles);
lab3->setText("  " + mostrar + tr(" Juegos "));
}
void ventanai::ffuncionan(bool onoff){
int totalVisibles=0;
guardarAnchoColumnas();

if (onoff){
  if (filtrar){
   QString estado;

   QListViewItem * item;

    QListViewItemIterator it( list1 );
    while ( it.current() != 0 ) {
           item=it.current();
           estado=item->text(5);
    if(estado.compare(tr("No"))==0) item->setVisible(0);
    else if(estado.compare(tr("Mal"))==0) item->setVisible(0);
    else if(estado.compare(tr("Si"))==0) {
               if (item->parent()!=NULL){
                  item->parent()->setVisible(1);
               }
               item->setVisible(1);
               totalVisibles++;
          }

        ++it;
    }

   QListViewItemIterator it2( list1 );
    while ( it2.current() != 0 ) {
       item=it2.current();
       estado=item->text(5);
       if (item->isVisible()) {
         if (item->parent()!=NULL){
           if(estado.compare(tr("Si"))!=0) {
              item->setVisible(0);
           }
         }
       }
       ++it2;
    }


    //apago los otros
    filtrar=0;
    neogeo->setOn(0);
    nodisponibles->setOn(0);
    romsmal->setOn(0);
    todos->setOn(0);
    Cps1->setOn(0);
    Cps2->setOn(0);
    Jugados->setOn(0);
    filtrar=1;
  } //termina filtrar
}
else{
  if (filtrar) todos->setOn(1);
}
QTimer::singleShot( 100, this, SLOT(ajustarcolumnas()) );
QString mostrar;mostrar.setNum(totalVisibles);
lab3->setText("  " + mostrar + tr(" Juegos "));
}

void ventanai::fnofuncionan(bool onoff){
int totalVisibles=0;
guardarAnchoColumnas();

if (onoff){
  if (filtrar){
   QString estado;

   QListViewItem * item;

    QListViewItemIterator it( list1 );
    while ( it.current() != 0 ) {
         item=it.current();
         estado=item->text(5);
         if(estado.compare(tr("Si"))==0) item->setVisible(0);
         else if(estado.compare(tr("No"))==0) {
             if (item->parent()!=NULL){
                  item->parent()->setVisible(1);
             }
             item->setVisible(1);
             totalVisibles++;
         }
         else if(estado.compare(tr("Mal"))==0) item->setVisible(0);
         ++it;
    } // del while

    QListViewItemIterator it2( list1 );
    while ( it2.current() != 0 ) {
       item=it2.current();
       estado=item->text(5);
       if (item->isVisible()) {
         if (item->parent()!=NULL){
           if(estado.compare(tr("No"))!=0) {
              item->setVisible(0);
           }
         }
       }
       ++it2;
    }
    
    //apago los otros
    filtrar=0;
    neogeo->setOn(0);
    romsmal->setOn(0);
    disponibles->setOn(0);
    todos->setOn(0);
    Cps1->setOn(0);
    Cps2->setOn(0);
    Jugados->setOn(0);
    filtrar=1;
  } //termina filtrar
}
else{
  if (filtrar) todos->setOn(1);
}
QTimer::singleShot( 100, this, SLOT(ajustarcolumnas()) );
QString mostrar;mostrar.setNum(totalVisibles);
lab3->setText("  " + mostrar + tr(" Juegos "));
}

void ventanai::fromsmal(bool onoff){
int totalVisibles=0;
guardarAnchoColumnas();

if (onoff){
  if (filtrar){
   QString estado;

   QListViewItem * item;

    QListViewItemIterator it( list1 );
    while ( it.current() != 0 ) {
           item=it.current();
           estado=item->text(5);
    if(estado.compare(tr("Mal"))==0) {
          if (item->parent()!=NULL){
              item->parent()->setVisible(1);
          }
          item->setVisible(1);
          totalVisibles++;
          }
    else if(estado.compare(tr("Si"))==0) item->setVisible(0);
    else if(estado.compare(tr("No"))==0) item->setVisible(0);
        ++it;
    }

    QListViewItemIterator it2( list1 );
    while ( it2.current() != 0 ) {
       item=it2.current();
       estado=item->text(5);
       if (item->isVisible()) {
         if (item->parent()!=NULL){
           if(estado.compare(tr("Mal"))!=0) {
              item->setVisible(0);
           }
         }
       }
       ++it2;
    }
    
    //apago los otros
    filtrar=0;
    neogeo->setOn(0);
    disponibles->setOn(0);
    nodisponibles->setOn(0);
    todos->setOn(0);
    Cps1->setOn(0);
    Cps2->setOn(0);
    Jugados->setOn(0);
    filtrar=1;
  } //termina filtrar
}
else{
  if (filtrar) todos->setOn(1);
}
QTimer::singleShot( 100, this, SLOT(ajustarcolumnas()) );
QString mostrar;mostrar.setNum(totalVisibles);
lab3->setText("  " + mostrar + tr(" Juegos "));
}

void ventanai::fneogeo(bool onoff){
guardarAnchoColumnas();
int totalVisibles=0;


if (onoff){
  if (filtrar){
   QString estado;

   QListViewItem * item;

    QListViewItemIterator it( list1 );
    while ( it.current() != 0 ) {
           item=it.current();
           estado=item->text(7);
    if(estado.compare("neogeo")==0) {
          item->setVisible(1);
          totalVisibles++;
          }
    else {
          item->setVisible(0);
    }
           
        ++it;
    }


    //apago los otros
    filtrar=0;
    nodisponibles->setOn(0);
    romsmal->setOn(0);
    disponibles->setOn(0);
    todos->setOn(0);
    Cps1->setOn(0);
    Cps2->setOn(0);
    Jugados->setOn(0);
    filtrar=1;
 } //del filtrar

}
else {
  if (filtrar) todos->setOn(1);
}

QTimer::singleShot( 100, this, SLOT(ajustarcolumnas()) );
QString mostrar;mostrar.setNum(totalVisibles);
lab3->setText("  " + mostrar + tr(" Juegos "));

}

void ventanai::cverificarroms(){
guardarAnchoColumnas();
ftodos(1);
int totalG=totalJuegos;
cantG=0;
progressG= new QProgressDialog( tr("Verificando rom: "), tr("Cancelar"), totalG ,this, "vprogress", TRUE );
progressG->show();


QListViewItemIterator it( list1 );
itVerifica=it;
itemG=itVerifica.current();

    if ( itemG != 0) {
//oculta
                    previa->hide();
                    vista->hide();
                    datos->hide();
                    list1->hide();
                    info->hide();
          QString lr="";
          lr=itemG->text(4);
          cantG++;
          progressG->setProgress( cantG );
          progressG->setLabelText(tr("Verificando rom: ") + lr);
//          qApp->processEvents();
          if ( progressG->wasCancelled() )return;
        proc = new QProcess( this );
        proc->setName(lr);
        proc->addArgument( fxmame );
        proc->addArgument( "-vr" );
        proc->addArgument( lr );
        connect( proc, SIGNAL(processExited()),
                this, SLOT(leerexitverificar()) );
// limpio salida
        if ( !proc->start() ) {
            QMessageBox:: warning( this, tr("Error"), tr("No se pudo verificar"));
        }
    } //del if
else{
progressG->setProgress( totalG );
}

} //del slot

void ventanai::leerexitverificar(){
QString salida=proc->readStdout();
 QListViewItem * item;
 QString lr=proc->name();

QString correct="romset ";
correct.append(proc->name());
correct.append(" correct");
//
QString incorrect="romset ";
incorrect.append(proc->name());
incorrect.append(" incorrect");
//
QString notfound="romset ";
notfound.append(proc->name());
notfound.append(" not found");
//
QString best="romset ";
best.append(proc->name());
best.append(" best");

            if (salida.find( QRegExp(correct), 0 )!=-1) {
                    item=list1->findItem(lr,4);
                         if (item!=0) {
                              lr=item->text(5);                  //cambio el contenido de lr
                              if(lr.compare(tr("Si"))!=0){
                                   item->setText(5, tr("Si"));
                                   QPixmap imagen3( ( const char** ) image3_data );
                                   item->setPixmap( 0, imagen3 );
                              }
                         }
            }
            else if (salida.find( QRegExp(best), 0 )!=-1) {
                    item=list1->findItem(lr,4);
                         if (item!=0) {
                              lr=item->text(5);                  //cambio el contenido de lr
                              if(lr.compare(tr("Si"))!=0){
                                   item->setText(5, tr("Si"));
                                   QPixmap imagen3( ( const char** ) image3_data );
                                   item->setPixmap( 0, imagen3 );
                              }
                         }
            }
            else if (salida.find( QRegExp(incorrect), 0 )!=-1) {
             item=list1->findItem(lr,4);
             if (item!=0) {
                  QFile farch(mameromdirF + "/" + item->text(4) + ".zip");
                  if (farch.exists()) {
                              lr=item->text(5);                  //cambio el contenido de lr
                              if(lr.compare(tr("Mal"))!=0){
                                   item->setText(5, tr("Mal"));
                                   QPixmap badrom( ( const char** ) badrom_data );
                                   item->setPixmap( 0, badrom );
                              }
                  }
                  else{
                              lr=item->text(5);                  //cambio el contenido de lr
                              if(lr.compare(tr("No"))!=0){
                                   item->setText(5, tr("No"));
                                   QPixmap imagen5( ( const char** ) image5_data );
                                   item->setPixmap( 0, imagen5 );
                              }
             }//del  else
            } //del si el item no es 0
            } //del else if
            else if (salida.find( QRegExp(notfound), 0 )!=-1) {
                    item=list1->findItem(lr,4);
                         if (item!=0) {
                              lr=item->text(5);                  //cambio el contenido de lr
                              if(lr.compare(tr("No"))!=0){
                                   item->setText(5, tr("No"));
                                   QPixmap imagen5( ( const char** ) image5_data );
                                   item->setPixmap( 0, imagen5 );
                              }
                         }
            }
//mueve a otro
++itVerifica;
itemG=itVerifica.current();

    if ( itemG != 0) {
          QString lr="";
          lr=itemG->text(4);
          cantG++;
          progressG->setProgress( cantG );
          progressG->setLabelText(tr("Verificando rom: ") + lr);
//          qApp->processEvents();
          if ( progressG->wasCancelled() ){
                    progressG->hide();
                    previa->show();
                    vista->show();
                    datos->show();
                    info->show();
                    list1->show();
                    return;
          }
        proc = new QProcess( this );
        proc->setName(lr);
        proc->addArgument( fxmame );
        proc->addArgument( "-vr" );
        proc->addArgument( lr );
        connect( proc, SIGNAL(processExited()),
                this, SLOT(leerexitverificar()) );
// limpio salida
        if ( !proc->start() ) {
            QMessageBox:: warning( this, tr("Error"), tr("No se pudo verificar"));
        }
    } //del if
else{
//progressG->setProgress( totalG );
progressG->hide();
previa->show();
vista->show();
datos->show();
info->show();
list1->show();
//  carga configuracion
QTimer::singleShot( 1000, this, SLOT(ajustarcolumnas()) );
}
} //fin del slot

void ventanai::Contraer_activated(){

   QListViewItem * item;

   QListViewItemIterator it( list1 );
    while ( it.current() != 0 ) {
           item=it.current();
           item->setOpen ( FALSE);
           ++it;
    }

}

void ventanai::Expandir_activated(){

   QListViewItem * item;

   QListViewItemIterator it( list1 );
    while ( it.current() != 0 ) {
           item=it.current();
           item->setOpen ( TRUE );
           ++it;
    }
}

void ventanai::Cps1_toggled( bool onoff){
guardarAnchoColumnas();
int totalVisibles=0;


if (onoff){
  if (filtrar){
   QString estado;

   QListViewItem * item;

    QListViewItemIterator it( list1 );
    while ( it.current() != 0 ) {
           item=it.current();
           estado=item->text(7);
    if(estado.compare("cps1")==0) {
          item->setVisible(1);
          totalVisibles++;
          }
    else {
          item->setVisible(0);
    }

        ++it;
    }

    //apago los otros
    filtrar=0;
    neogeo->setOn(0);
    nodisponibles->setOn(0);
    romsmal->setOn(0);
    disponibles->setOn(0);
    todos->setOn(0);
    Cps2->setOn(0);
    Jugados->setOn(0);
    filtrar=1;
 } //del filtrar

}
else {
  if (filtrar) todos->setOn(1);
}

QTimer::singleShot( 100, this, SLOT(ajustarcolumnas()) );
QString mostrar;mostrar.setNum(totalVisibles);
lab3->setText("  " + mostrar + tr(" Juegos "));

}
void ventanai::Cps2_toggled( bool onoff ){
guardarAnchoColumnas();
int totalVisibles=0;


if (onoff){
  if (filtrar){
   QString estado;

   QListViewItem * item;

    QListViewItemIterator it( list1 );
    while ( it.current() != 0 ) {
           item=it.current();
           estado=item->text(7);
    if(estado.compare("cps2")==0) {
          item->setVisible(1);
          totalVisibles++;
          }
    else {
          item->setVisible(0);
    }

        ++it;
    }

    //apago los otros
    filtrar=0;
    neogeo->setOn(0);
    nodisponibles->setOn(0);
    romsmal->setOn(0);
    disponibles->setOn(0);
    todos->setOn(0);
    Cps1->setOn(0);
    Jugados->setOn(0);
    filtrar=1;
 } //del filtrar

}
else {
  if (filtrar) todos->setOn(1);
}

QTimer::singleShot( 100, this, SLOT(ajustarcolumnas()) );
QString mostrar;mostrar.setNum(totalVisibles);
lab3->setText("  " + mostrar + tr(" Juegos "));
}

void ventanai::Jugados_toggled( bool onoff){
guardarAnchoColumnas();
int totalVisibles=0;


if (onoff){
  if (filtrar){
   QString estado;

   QListViewItem * item;
    QListViewItemIterator it( list1 );
    while ( it.current() != 0 ) {
           item=it.current();
           estado=item->text(8);
    if(estado.compare(tr("0"))==0) item->setVisible(0);
    else {
               if (item->parent()!=NULL){
                  item->parent()->setVisible(1);
               }
               item->setVisible(1);
               totalVisibles++;
          }

        ++it;
    }

   QListViewItemIterator it2( list1 );
    while ( it2.current() != 0 ) {
       item=it2.current();
       estado=item->text(8);
       if (item->isVisible()) {
         if (item->parent()!=NULL){
           if(estado.compare(tr("0"))==0) {
              item->setVisible(0);
           }
         }
       }
       ++it2;
    }

    //apago los otros
    filtrar=0;
    neogeo->setOn(0);
    nodisponibles->setOn(0);
    romsmal->setOn(0);
    disponibles->setOn(0);
    todos->setOn(0);
    Cps1->setOn(0);
    Cps2->setOn(0);
    filtrar=1;
 } //del filtrar

}
else {
  if (filtrar) todos->setOn(1);
}

QTimer::singleShot( 100, this, SLOT(ajustarcolumnas()) );
QString mostrar;mostrar.setNum(totalVisibles);
lab3->setText("  " + mostrar + tr(" Juegos "));

}

void ventanai::fontListado_activated(){
    bool ok;
    QFont font = QFontDialog::getFont(
                    &ok, QFont( "Helvetica [Cronyx]", 10 ), this );
    if ( ok ) {
          list1->setFont(font);
    }
  
}
void ventanai::fontConfig_activated(){
    bool ok;
    QFont font = QFontDialog::getFont(
                    &ok, QFont( "Helvetica [Cronyx]", 10 ), this );
    if ( ok ) {
          QSettings conf;
          conf.writeEntry( "/qtmame/general/fuenteConfig",  font.toString());
        // font is set to the font the user selected
    }

}
void ventanai::fontInfo_activated(){
    bool ok;
    QFont font = QFontDialog::getFont(
                    &ok, QFont( "Helvetica [Cronyx]", 10 ), this );
    if ( ok ) {
          datos->setFont(font);
        // font is set to the font the user selected
    } 

}

void ventanai::cListado_activated(){
    bool ok;
    QColor color = QColorDialog::getRgba(0,&ok , this );
    if ( ok ) {
          list1->setPaletteForegroundColor(color);
          QPalette pal;
          pal=list1->palette();
          datos->setPalette( pal );
          statusBar()->setPaletteForegroundColor(color);
    }

}

void ventanai::fImagen_activated(){

QString directorioElegido;
directorioElegido=QFileDialog::getOpenFileName("/","*",this,tr("Elegir un Archivo..."),tr("Seleccione el Archivo de fondo: ") );
QFile f(directorioElegido);
if (f.exists()) {
QSettings conf;
       QPixmap img(directorioElegido);
       list1->setPaletteBackgroundPixmap(img);
       this->setPaletteBackgroundPixmap(img);
       QPalette pal;
       pal=list1->palette();
       datos->setPalette( pal );
       statusBar()->setPaletteBackgroundPixmap(img);
       conf.writeEntry( "/qtmame/general/imagenFondo", directorioElegido);      
}       
     
}

void ventanai::fColor_activated(){
QSettings conf;
    bool ok;
    QColor color = QColorDialog::getRgba(0,&ok , this );
    if ( ok ) {
       list1->setPaletteBackgroundPixmap(NULL);
       this->setPaletteBackgroundPixmap(NULL);
       statusBar()->setPaletteBackgroundPixmap(NULL);
          list1->setPaletteBackgroundColor(color);
          this->setPaletteBackgroundColor(color);
          QPalette pal;
          pal=list1->palette();
          datos->setPalette( pal );
          statusBar()->setPaletteBackgroundColor(color);
          conf.writeEntry( "/qtmame/general/colorFondo",  color.name());         
          conf.writeEntry( "/qtmame/general/imagenFondo", "No");
    }

}



